Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/STO/stopar.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/STO/stopar.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/STO/stopar.F90	(revision 10986)
@@ -275,4 +275,5 @@
             WRITE(numout,*) 'sto_par_init : NO use of stochastic parameterization'
             WRITE(numout,*) '~~~~~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
          RETURN
@@ -327,10 +328,8 @@
          ! WRITE(numout,*) '      passes of Laplacian filter              nn_trc_flt    = ', nn_trc_flt
          ! WRITE(numout,*) '      limitation factor                       rn_trc_lim    = ', rn_trc_lim
-
-      ENDIF
-
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '   stochastic parameterization :'
-
+         WRITE(numout,*)
+         WRITE(numout,*) '   stochastic parameterization :'
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       ! Set number of 2D stochastic arrays
       jpsto2d = 0
@@ -388,4 +387,5 @@
          jsto_trd  = jpsto3d
       ENDIF
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
 
       ! Allocate 2D stochastic arrays
@@ -698,4 +698,5 @@
             WRITE(numout,*) 'sto_rst_read : read stochastic parameters from restart file'
             WRITE(numout,*) '~~~~~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -758,4 +759,5 @@
                WRITE(numout,*) 'sto_rst_write : write stochastic parameters in restart file'
                WRITE(numout,*) '~~~~~~~~~~~~~'
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
          ENDIF
@@ -804,4 +806,5 @@
                   WRITE(numout,*) '             kt = '             , kt
                ENDIF
+               IF(lflush) CALL FLUSH(numout)
             ENDIF
             ! open the restart file
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/eosbn2.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/eosbn2.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/eosbn2.F90	(revision 10986)
@@ -1253,4 +1253,5 @@
          WRITE(numout,*) '      EOS-80  : rho=F(Potential    Temperature, Practical Salinity, depth)   ln_EOS80  = ', ln_EOS80
          WRITE(numout,*) '      S-EOS   : rho=F(Conservative Temperature, Absolute  Salinity, depth)   ln_SEOS   = ', ln_SEOS
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -1669,4 +1670,5 @@
          !
       END SELECT
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
       !
       rau0_rcp    = rau0 * rcp 
@@ -1684,13 +1686,17 @@
             WRITE(numout,*) '   ==>>>   model does not use Conservative Temperature'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '   Associated physical constant'
-      IF(lwp) WRITE(numout,*) '      volumic mass of reference           rau0  = ', rau0   , ' kg/m^3'
-      IF(lwp) WRITE(numout,*) '      1. / rau0                        r1_rau0  = ', r1_rau0, ' m^3/kg'
-      IF(lwp) WRITE(numout,*) '      ocean specific heat                 rcp   = ', rcp    , ' J/Kelvin'
-      IF(lwp) WRITE(numout,*) '      rau0 * rcp                       rau0_rcp = ', rau0_rcp
-      IF(lwp) WRITE(numout,*) '      1. / ( rau0 * rcp )           r1_rau0_rcp = ', r1_rau0_rcp
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '   Associated physical constant'
+         WRITE(numout,*) '      volumic mass of reference           rau0  = ', rau0   , ' kg/m^3'
+         WRITE(numout,*) '      1. / rau0                        r1_rau0  = ', r1_rau0, ' m^3/kg'
+         WRITE(numout,*) '      ocean specific heat                 rcp   = ', rcp    , ' J/Kelvin'
+         WRITE(numout,*) '      rau0 * rcp                       rau0_rcp = ', rau0_rcp
+         WRITE(numout,*) '      1. / ( rau0 * rcp )           r1_rau0_rcp = ', r1_rau0_rcp
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
       !
    END SUBROUTINE eos_init
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv.F90	(revision 10986)
@@ -220,4 +220,5 @@
          WRITE(numout,*) '            vertical   2nd/4th order               nn_ubs_v   = ', nn_ubs_v
          WRITE(numout,*) '      QUICKEST scheme                           ln_traadv_qck = ', ln_traadv_qck
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -265,4 +266,5 @@
          CASE( np_QCK     )   ;   WRITE(numout,*) '   ==>>>   QUICKEST scheme is used'
          END SELECT
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_cen.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_cen.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_cen.F90	(revision 10986)
@@ -80,8 +80,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv_cen : centered advection scheme on ', cdtype, ' order h/v =', kn_cen_h,'/', kn_cen_v
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~ '
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_adv_cen : centered advection scheme on ', cdtype, ' order h/v =', kn_cen_h,'/', kn_cen_v
+         WRITE(numout,*) '~~~~~~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                          ! set local switches
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_fct.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_fct.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_fct.F90	(revision 10986)
@@ -88,8 +88,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv_fct : FCT advection scheme on ', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_adv_fct : FCT advection scheme on ', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_mus.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_mus.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_mus.F90	(revision 10986)
@@ -92,9 +92,12 @@
       !
       IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv : MUSCL advection scheme on ', cdtype
-         IF(lwp) WRITE(numout,*) '        : mixed up-stream           ', ld_msc_ups
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
-         IF(lwp) WRITE(numout,*)
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'tra_adv : MUSCL advection scheme on ', cdtype
+            WRITE(numout,*) '        : mixed up-stream           ', ld_msc_ups
+            WRITE(numout,*) '~~~~~~~'
+            WRITE(numout,*)
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          ! Upstream / MUSCL scheme indicator
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_qck.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_qck.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_qck.F90	(revision 10986)
@@ -94,9 +94,10 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv_qck : 3rd order quickest advection scheme on ', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
-         IF(lwp) WRITE(numout,*)
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_adv_qck : 3rd order quickest advection scheme on ', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_ubs.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_ubs.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traadv_ubs.F90	(revision 10986)
@@ -101,8 +101,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_adv_ubs :  horizontal UBS advection scheme on ', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~'
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_adv_ubs :  horizontal UBS advection scheme on ', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbc.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbc.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbc.F90	(revision 10986)
@@ -151,4 +151,5 @@
          WRITE(numout,*) '      Constant geothermal flux value               rn_geoflx_cst = ', rn_geoflx_cst
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -188,4 +189,5 @@
          IF(lwp) WRITE(numout,*) '   ==>>>   no geothermal heat flux'
       ENDIF
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
       !
    END SUBROUTINE tra_bbc_init
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbl.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trabbl.F90	(revision 10986)
@@ -335,8 +335,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp)  WRITE(numout,*)
-         IF(lwp)  WRITE(numout,*) 'trabbl:bbl : Compute bbl velocities and diffusive coefficients in ', cdtype
-         IF(lwp)  WRITE(numout,*) '~~~~~~~~~~'
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'trabbl:bbl : Compute bbl velocities and diffusive coefficients in ', cdtype
+         WRITE(numout,*) '~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                                        !* bottom variables (T, S, alpha, beta, depth, velocity)
@@ -500,4 +501,5 @@
          WRITE(numout,*) '       Namelist nambbl : set bbl parameters'
          WRITE(numout,*) '          bottom boundary layer flag          ln_trabbl  = ', ln_trabbl
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       IF( .NOT.ln_trabbl )   RETURN
@@ -508,4 +510,5 @@
          WRITE(numout,*) '          diffusive bbl coefficient           rn_ahtbbl  = ', rn_ahtbbl, ' m2/s'
          WRITE(numout,*) '          advective bbl coefficient           rn_gambbl  = ', rn_gambbl, ' s'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -513,6 +516,8 @@
       IF( tra_bbl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'tra_bbl_init : unable to allocate arrays' )
       !
-      IF( nn_bbl_adv == 1 )    WRITE(numout,*) '       * Advective BBL using upper velocity'
-      IF( nn_bbl_adv == 2 )    WRITE(numout,*) '       * Advective BBL using velocity = F( delta rho)'
+      IF(lwp) THEN
+         IF( nn_bbl_adv == 1 )    WRITE(numout,*) '       * Advective BBL using upper velocity'
+         IF( nn_bbl_adv == 2 )    WRITE(numout,*) '       * Advective BBL using velocity = F( delta rho)'
+      ENDIF
       !
       !                             !* vertical index of  "deep" bottom u- and v-points
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tradmp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tradmp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tradmp.F90	(revision 10986)
@@ -195,4 +195,5 @@
          WRITE(numout,*) '         Damping file name               cn_resto = ', cn_resto
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -208,4 +209,5 @@
             CALL ctl_stop('tra_dmp_init : wrong value of nn_zdmp')
          END SELECT
+         IF(lwp .AND. lflush) CALL FLUSH(numout)
          !
          !!TG: Initialisation of dtatsd - Would it be better to have dmpdta routine
@@ -213,6 +215,9 @@
          !!gm: In principle yes. Nevertheless, we can't anticipate demands that have never been formulated.
          IF( .NOT.ln_tsd_dmp ) THEN
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout, *)  '   read T-S data not initialized, we force ln_tsd_dmp=T'
+            IF(lwp) THEN
+               WRITE(numout,*)
+               WRITE(numout, *)  '   read T-S data not initialized, we force ln_tsd_dmp=T'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             CALL dta_tsd_init( ld_tradmp=ln_tradmp )        ! forces the initialisation of T-S data
          ENDIF
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf.F90	(revision 10986)
@@ -121,4 +121,5 @@
          CASE( np_blp_it )   ;   WRITE(numout,*) '   ==>>>   Rotated bilaplacian operator (triad)'
          END SELECT
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_iso.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_iso.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_iso.F90	(revision 10986)
@@ -114,7 +114,10 @@
       !
       IF( kpass == 1 .AND. kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_iso : rotated laplacian diffusion operator on ', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'tra_ldf_iso : rotated laplacian diffusion operator on ', cdtype
+            WRITE(numout,*) '~~~~~~~~~~~'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          akz     (:,:,:) = 0._wp      
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_lap_blp.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_lap_blp.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_lap_blp.F90	(revision 10986)
@@ -85,4 +85,5 @@
          WRITE(numout,*) 'tra_ldf_lap : iso-level laplacian diffusion on ', cdtype, ', pass=', kpass
          WRITE(numout,*) '~~~~~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -199,4 +200,5 @@
          END SELECT
          WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_triad.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_triad.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traldf_triad.F90	(revision 10986)
@@ -102,8 +102,9 @@
       ENDIF
      !
-      IF( kpass == 1 .AND. kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_triad : rotated laplacian diffusion operator on ', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~'
+      IF( kpass == 1 .AND. kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_ldf_triad : rotated laplacian diffusion operator on ', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !   
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tramle.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tramle.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tramle.F90	(revision 10986)
@@ -289,4 +289,5 @@
          WRITE(numout,*) '         =1 no MLE in case of convection ; =0 always MLE              nn_conv   = ', nn_conv
          WRITE(numout,*) '         Density difference used to define ML for FK              rn_rho_c_mle  = ', rn_rho_c_mle
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -300,4 +301,5 @@
             WRITE(numout,*) '   ==>>>   Mixed Layer Eddy parametrisation NOT used'
          ENDIF
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -305,7 +307,10 @@
          !
          rb_c = grav * rn_rho_c_mle /rau0        ! Mixed Layer buoyancy criteria
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) '      ML buoyancy criteria = ', rb_c, ' m/s2 '
-         IF(lwp) WRITE(numout,*) '      associated ML density criteria defined in zdfmxl = ', rho_c, 'kg/m3'
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '      ML buoyancy criteria = ', rb_c, ' m/s2 '
+            WRITE(numout,*) '      associated ML density criteria defined in zdfmxl = ', rho_c, 'kg/m3'
+            IF(lflush) CALL FLUSH(numout)
+         ENDIF
          !
          IF( nn_mle == 0 ) THEN           ! MLE array allocation & initialisation
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tranxt.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tranxt.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/tranxt.F90	(revision 10986)
@@ -95,8 +95,9 @@
       IF( ln_timing )   CALL timing_start( 'tra_nxt')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_nxt : achieve the time stepping by Asselin filter and array swap'
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_nxt : achieve the time stepping by Asselin filter and array swap'
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -213,8 +214,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_nxt_fix : time stepping', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_nxt_fix : time stepping', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -271,8 +273,9 @@
       !!----------------------------------------------------------------------
       !
-      IF( kt == kit000 )  THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_nxt_vvl : time stepping', cdtype
-         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
+      IF( kt == kit000 .AND. lwp)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_nxt_vvl : time stepping', cdtype
+         WRITE(numout,*) '~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traqsr.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traqsr.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/traqsr.F90	(revision 10986)
@@ -118,8 +118,9 @@
       IF( ln_timing )   CALL timing_start('tra_qsr')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_qsr : penetration of the surface solar radiation'
+         WRITE(numout,*) '~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -135,5 +136,8 @@
 !!gm case neuler  not taken into account....
          IF( ln_rstart .AND. iom_varid( numror, 'qsr_hc_b', ldstop = .FALSE. ) > 0 ) THEN    ! read in restart
-            IF(lwp .AND. nprint >0) WRITE(numout,*) '          nit000-1 qsr tracer content forcing field read in the restart file'
+            IF(lwp .AND. nprint >0) THEN
+               WRITE(numout,*) '          nit000-1 qsr tracer content forcing field read in the restart file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             z1_2 = 0.5_wp
             CALL iom_get( numror, jpdom_autoglo, 'qsr_hc_b', qsr_hc_b, ldxios = lrxios )   ! before heat content trend due to Qsr flux
@@ -358,4 +362,5 @@
          WRITE(numout,*) '      2 bands: longest depth of extinction         rn_si1     = ', rn_si1
          WRITE(numout,*)
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -418,4 +423,5 @@
          !
       END SELECT
+      IF(lwp .AND. lflush) CALL FLUSH(numout)
       !
       qsr_hc(:,:,:) = 0._wp     ! now qsr heat content set to zero where it will not be computed
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trasbc.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trasbc.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trasbc.F90	(revision 10986)
@@ -82,8 +82,9 @@
       IF( ln_timing )   CALL timing_start('tra_sbc')
       !
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_sbc : TRAcer Surface Boundary Condition'
-         IF(lwp) WRITE(numout,*) '~~~~~~~ '
+      IF( kt == nit000 .AND. lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_sbc : TRAcer Surface Boundary Condition'
+         WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
@@ -107,5 +108,8 @@
          IF( ln_rstart .AND.    &               ! Restart: read in restart file
               & iom_varid( numror, 'sbc_hc_b', ldstop = .FALSE. ) > 0 ) THEN
-            IF(lwp .AND. nprint > 0) WRITE(numout,*) '          nit000-1 sbc tracer content field read in the restart file'
+            IF(lwp .AND. nprint > 0) THEN
+               WRITE(numout,*) '          nit000-1 sbc tracer content field read in the restart file'
+               IF(lflush) CALL FLUSH(numout)
+            ENDIF
             zfact = 0.5_wp
             sbc_tsc(:,:,:) = 0._wp
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trazdf.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trazdf.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRA/trazdf.F90	(revision 10986)
@@ -58,8 +58,9 @@
       IF( ln_timing )   CALL timing_start('tra_zdf')
       !
-      IF( kt == nit000 )  THEN
-         IF(lwp)WRITE(numout,*)
-         IF(lwp)WRITE(numout,*) 'tra_zdf : implicit vertical mixing on T & S'
-         IF(lwp)WRITE(numout,*) '~~~~~~~ '
+      IF( kt == nit000 .AND. lflush)  THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'tra_zdf : implicit vertical mixing on T & S'
+         WRITE(numout,*) '~~~~~~~ '
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdglo.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdglo.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdglo.F90	(revision 10986)
@@ -282,4 +282,5 @@
             WRITE (numout,9513) umo(jpdyn_tau) / tvolu, vmo(jpdyn_tau) / tvolv
 !!gm            IF( ln_drgimp )   WRITE (numout,9514) umo(jpdyn_bfri) / tvolu, vmo(jpdyn_bfri) / tvolv
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -321,4 +322,5 @@
             WRITE (numout,9533) hke(jpdyn_tau) / tvolt
 !!gm            IF( ln_drgimp )   WRITE (numout,9534) hke(jpdyn_bfri) / tvolt
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -353,4 +355,5 @@
             WRITE (numout,*)
             WRITE (numout,*)
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -419,4 +422,5 @@
             &                   (  smo(jptra_xad) + smo(jptra_yad) + smo(jptra_zad) + smo(jptra_ldf) + smo(jptra_zdf)   &
             &                    + smo(jptra_npc) + smo(jptra_dmp)                   + smo(jptra_nsr) ) / tvolt
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -454,4 +458,5 @@
             &                   (  s2(jptra_xad) + s2(jptra_yad) + s2(jptra_zad) + s2(jptra_ldf) + s2(jptra_zdf)   &
             &                    + s2(jptra_npc) + s2(jptra_dmp)                  + s2(jptra_nsr) ) / tvolt
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -486,4 +491,5 @@
             WRITE (numout,9448)   t2(jptra_zdf)/tvolt,   s2(jptra_zdf)/tvolt
             WRITE (numout,9449)   t2(jptra_npc)/tvolt,   s2(jptra_npc)/tvolt
+            IF(lflush) CALL FLUSH(numout)
          ENDIF
 
@@ -519,4 +525,5 @@
          WRITE(numout,*) 'trd_glo_init : integral constraints properties trends'
          WRITE(numout,*) '~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
@@ -528,5 +535,8 @@
       CALL mpp_sum( 'trdglo', tvolt )   ! sum over the global domain
 
-      IF(lwp) WRITE(numout,*) '                total ocean volume at T-point   tvolt = ',tvolt
+      IF(lwp) THEN
+         WRITE(numout,*) '                total ocean volume at T-point   tvolt = ',tvolt
+         IF(lflush) CALL FLUSH(numout)
+      ENDIF
 
       ! Initialization of potential to kinetic energy conversion
@@ -552,4 +562,5 @@
          WRITE(numout,*) '                total ocean volume at U-point   tvolu = ',tvolu
          WRITE(numout,*) '                total ocean volume at V-point   tvolv = ',tvolv
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdini.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdini.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdini.F90	(revision 10986)
@@ -70,4 +70,5 @@
          !
          WRITE(numout,*) '      frequency of trends diagnostics (glo)     nn_trd      = ', nn_trd
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdken.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdken.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdken.F90	(revision 10986)
@@ -247,4 +247,5 @@
          WRITE(numout,*) 'trd_ken_init : 3D Kinetic Energy trends'
          WRITE(numout,*) '~~~~~~~~~~~~~'
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
       !                           ! allocate box volume arrays
Index: NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl.F90
===================================================================
--- NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl.F90	(revision 10985)
+++ NEMO/branches/UKMO/NEMO_4.0_mirror_text_diagnostics/src/OCE/TRD/trdmxl.F90	(revision 10986)
@@ -373,4 +373,5 @@
          IF( ln_ctl ) THEN
             WRITE(numout,*) '             we reach kt == nit000 + 1 = ', nit000+1
+            IF(lflush) CALL FLUSH(numout)
             CALL prt_ctl(tab2d_1=tmlbb   , clinfo1=' tmlbb   -   : ', mask1=tmask)
             CALL prt_ctl(tab2d_1=tmlbn   , clinfo1=' tmlbn   -   : ', mask1=tmask)
@@ -383,4 +384,5 @@
          IF( ln_trdmxl_instant ) THEN
             WRITE(numout,*) '             restart from kt == nit000 = ', nit000
+            IF(lflush) CALL FLUSH(numout)
             CALL prt_ctl(tab2d_1=tmlbb   , clinfo1=' tmlbb   -   : ', mask1=tmask)
             CALL prt_ctl(tab2d_1=tmlbn   , clinfo1=' tmlbn   -   : ', mask1=tmask)
@@ -388,4 +390,5 @@
          ELSE
             WRITE(numout,*) '             restart from kt == nit000 = ', nit000
+            IF(lflush) CALL FLUSH(numout)
             CALL prt_ctl(tab2d_1=tmlbn          , clinfo1=' tmlbn           -  : ', mask1=tmask)
             CALL prt_ctl(tab2d_1=hmxlbn         , clinfo1=' hmxlbn          -  : ', mask1=tmask)
@@ -611,4 +614,5 @@
             WRITE(numout,*) '          TRA zsmlres (jpi/2,jpj/2) : ', zsmlres (jpi/2,jpj/2)
             WRITE(numout,*) '          TRA zsmlres2(jpi/2,jpj/2) : ', zsmlres2(jpi/2,jpj/2)
+            IF(lflush) CALL FLUSH(numout)
             !
          END IF
@@ -753,4 +757,5 @@
          WRITE(numout,*) '      unit conversion factor                     rn_ucf             = ', rn_ucf
          WRITE(numout,*) '      criteria to compute the MLD                rn_rho_c           = ', rn_rho_c
+         IF(lflush) CALL FLUSH(numout)
       ENDIF
 
